<?php

namespace Passimpay\PassimpayPayment\Controller\Checkout;

class Success extends \Magento\Framework\App\Action\Action
{
    /**
     * @var \Passimpay\PassimpayPayment\Model\Config
     */
    protected $_config;

    /**
     * @var \Magento\Framework\Message\ManagerInterface
     */
    protected $messageManager;

    /**
     * @var \Magento\Checkout\Model\Session
     */
    protected $_checkoutSession;

    /**
     * @var \Psr\Log\LoggerInterface
     */
    protected $_logger;

    /**
     * @var Helper
     */
    protected $_helper;

    /**
     * @var PaymentHelper
     */
    protected $_paymentHelper;

    /**
     * @var OrderSender
     */
    protected $_orderSender;

    /**
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\Message\ManagerInterface $messageManager
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Psr\Log\LoggerInterface $logger,
        \Magento\Payment\Helper\Data $paymentHelper,
        \Magento\Sales\Model\Order\Email\Sender\OrderSender $orderSender
    )
    {
        $this->_checkoutSession = $checkoutSession;
        $this->_logger = $logger;
        $this->_paymentHelper = $paymentHelper;
        $this->_orderSender = $orderSender;

        parent::__construct($context);
    }

    public function execute()
    {
//        $order = $this->_getCheckoutSession()->getLastRealOrder();

//        throw new \Exception(json_encode([
//            'session' => $this->_getCheckoutSession(),
//            'order' => $order,
//        ]));

        try {
            $resultRedirect = $this->resultRedirectFactory->create();

//            $message = __('Redirected to order success page.');
//            $order->addStatusHistoryComment($message)->save();
//
//            $this->_orderSender->send($order);

            $this->_getCheckoutSession()->start();
            $resultRedirect->setPath('checkout/onepage/success');
            return $resultRedirect;

       } catch (\Exception $e) {
            $this->messageManager->addException($e, __('Something went wrong, please try again later'));
            $this->_logger->critical($e);
            $this->_getCheckoutSession()->restoreQuote();
            $this->_redirect('checkout/cart');
        }
    }

    /**
     * Return checkout session object
     *
     * @return \Magento\Checkout\Model\Session
     */
    protected function _getCheckoutSession()
    {
        return $this->_checkoutSession;
    }
}
